{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   puz_disp.pp                                          }
{     ѥ륲 base ʬβ̥饹                 }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: puz_disp.pp,v 1.4 2002/08/10 03:05:14 rero2 Exp $ }
Unit Puz_Disp;

{$MODE Delphi}


interface

Uses classes, SDL, SDL_Types, SDL_Video, Puz_Base, Grp_Screen, Grp_Sprite,
     Debug, Math;

Const
  ObjMax = 185;
  TexMax = 4;
  FieldTop = 28;
  KiraMax = 36;


Type
  GameMode = (
    MODE_CHALLENGE,
    MODE_1P,
    MODE_2P);

  { ------------------------------------- }
  { ----- 餭饨ե }
  type Kira = record
    DispSw: Boolean;
    obj: TGameSprite;
    timer: Integer;
    timer_end: Integer;
    x, y: Integer;
    dx, dy: Integer;
  end;

  { ------------------------------------- }
  { ----- طʤΥ̥ }
  type TanuPos = record
    x, y: Integer;
  end;

  { ------------------------------------- }
  { ----- ѥ̥饹 }
  TPuzzleDisp = class(TPuzzleBase)
    protected
    puz_mode: GameMode;
    fieldpos_x: Integer;
    { --- ƥ֥ }
    obj: Array [0..ObjMax] of TGameSprite;
    { --- ƥƥ }
    texture: Array [0..TexMax] of PSDL_Surface;
    procedure DispField;
    procedure DispReady(time: Integer);
    procedure DispGameover(time: Integer);
    procedure DispClear;
    procedure KiraRequest(x, y, l: Integer);
    private
    { --- ᤭ե }
    kirakira: Array [0..KiraMax] of Kira;
    tanuki: Array [0..3] of TanuPos;
    screen: TGameScreen;
    disptimer: Integer;
    procedure DispCursor;
    procedure DispBlock;
    procedure DispEraseBlock(obj:TGameSprite; bl: PBlock);
    procedure DispBack;
    procedure DispChara;
    procedure DispNext;
    procedure DispScore;
    procedure DispNum(x, y, n, o, num: Integer);
    procedure DispKira;
    { ------------------- }
    { --- ʬ }
    public
    constructor Create(mode: GameMode; scr: TGameScreen);
    destructor Destroy; virtual;
  end;


implementation
{ -------------------------------------------------------------- }
{ --- ѥեɽ饹                                 }
{ -------------------------------------------------------------- }

var
  animekoma: Array [0..7] of Integer = (0, 0, 0, 0, 0, 1, 2, 1);

{ ---------------------------------------- }
{ --- 󥹥ȥ饯ǥȥ饯         }

constructor TPuzzleDisp.Create(mode: GameMode; scr: TGameScreen);
var
  objstep: Integer;
  i, j: Integer;
begin
  inherited Create;
  { ------------------------------------- }
  { ----- 줳 }
  puz_mode := mode;
  screen := scr;
  disptimer := 0;
  { --- ⡼ɤˤäƥեɽ֤㤦 }
  case mode of
    MODE_CHALLENGE:
      begin
        fieldpos_x := 81;
        objstep := 0;
        j := 0;
      end;
    MODE_1P:
      begin
        fieldpos_x := 0;
        objstep := 0;
        j := 0;
      end;
    MODE_2P:
      begin
        fieldpos_x := 240;
        objstep := 1;
        j := 1;
      end;
  end;
  { ------------------------------------- }
  { ----- ɽ }
  for i := 0 to TexMax do
  begin
    texture[i] := scr.GetTexture(2+j+(i*2)+objstep);
  end;
  for i := 0 to ObjMax do
  begin
    obj[i] := scr.GetSprite(1+j+(i*2)+objstep);
  end;
  for i := 0 to KiraMax do
  begin
    kirakira[i].DispSw := False;
    kirakira[i].obj := obj[123+i];
  end;
  tanuki[0].y := 400;
  tanuki[1].y := 500;
  tanuki[2].y := 600;
  tanuki[3].y := 700;
  tanuki[0].x := Random(BLOCK_WIDTH*FIELD_WIDTH-60);
  tanuki[1].x := Random(BLOCK_WIDTH*FIELD_WIDTH-60);
  tanuki[2].x := Random(BLOCK_WIDTH*FIELD_WIDTH-60);
  tanuki[3].x := Random(BLOCK_WIDTH*FIELD_WIDTH-60);
end;


destructor  TPuzzleDisp.Destroy;
var
  i : Integer;
begin
  for i := 0 to ObjMax do
  begin
    obj[i].DispSW := False;
  end;

  inherited;
end;



procedure  TPuzzleDisp.DispClear;
var
  i : Integer;
begin
  for i := 0 to ObjMax do
  begin
    obj[i].DispSW := False;
  end;
end;


{ ---------------------------------------- }
{ --- եɽ                 }

procedure TPuzzleDisp.DispField;
begin
  DispTimer := DispTimer + 1;
  { ------------------------------------- }
  { ----- طʤɽ }
  DispBack;
  { ------------------------------------- }
  { ----- ֥åɽ }
  DispBlock;
  { ------------------------------------- }
  { ----- ɽ }
  DispCursor;
  { ------------------------------------- }
  { ----- 饯ɽ }
  DispChara;
  { ------------------------------------- }
  { ----- NEXT ɽ }
  DispNext;
  { ------------------------------------- }
  { ----- ɽ }
  DispScore;
  { ------------------------------------- }
  { ----- 餭饨եȤɽ }
  DispKira;
end;


{ -------------------------------------------------------------- }
{ --- Ƽ                                               }
{ -------------------------------------------------------------- }

{ ---------------------------------------- }
{ --- ץ쥤䡼ɽ               }
procedure TPuzzleDisp.DispCursor;
var
  x, y: Integer;
begin
  { ----- ϥɥ }
  x := fieldpos_x + (ua.x * BLOCK_WIDTH) + 4;
  y := FieldTop + ((FIELD_HEIGHT - ua.y - 1) * BLOCK_WIDTH) + 4;
  obj[122].DispSw := True;
  obj[122].x := x + ua.SwapOffsetX;
  obj[122].y := y + ua.SwapOffsetY + ua.PopupOffset;
  obj[122].w := BLOCK_WIDTH;
  obj[122].h := BLOCK_HEIGHT;
  if ua.HaveBlock = False then
    obj[122].tx := 24 * 2
  else
    obj[122].tx := 24 * 3;
  obj[122].ty := 24 * 2;
  obj[122].Texture := texture[0];
  obj[122].alpha := 255;
  { ----- Ĥߥ֥å }
  if ua.HaveBlock = True then
  begin
    x := fieldpos_x + (ua.x * BLOCK_WIDTH);
    y := FieldTop + ((FIELD_HEIGHT - ua.y - 1) * BLOCK_WIDTH);
    obj[121].DispSw := True;
    obj[121].x := x + ua.SwapOffsetX;
    obj[121].y := y + ua.SwapOffsetY + ua.PopupOffset;
    obj[121].w := BLOCK_WIDTH;
    obj[121].h := BLOCK_HEIGHT;
    if (DispTimer mod 2) = 0 then
      obj[121].tx := 24 * 0
    else
      obj[121].tx := 24 * 1;
    obj[121].ty := 24 * 2;
    obj[121].Texture := texture[0];
    obj[121].alpha := 255;
  end
  else
    obj[121].DispSw := False;
end;


{ ---------------------------------------- }
{ --- եɥ֥åɽ               }
procedure TPuzzleDisp.DispBlock;
var
  i: Integer;
  colx, coly: Integer;
  x, y: Integer;
begin
  for i := 0 to (FIELD_WIDTH * FIELD_HEIGHT) - 1 do
  begin
    if Field[i] <> nil then
    begin
      if Field[i].Color <> 0 then
      begin
        if Field[i].Color >= $10 then
        begin
          colx := ((Field[i].Color - $10) - 1) * BLOCK_WIDTH;
          coly := BLOCK_HEIGHT;
        end
        else
        begin
          colx := (Field[i].Color - 1) * BLOCK_WIDTH;
          coly := 0;
        end;
        x := ((i mod FIELD_WIDTH) * BLOCK_WIDTH);
        if (i div FIELD_WIDTH) = 0 then
          y := ((FIELD_HEIGHT - 1) - (i div FIELD_WIDTH)) * BLOCK_HEIGHT + 4 + FieldTop
        else          
          y := ((FIELD_HEIGHT - 1) - (i div FIELD_WIDTH)) * BLOCK_HEIGHT + FieldTop;
        obj[10+i].DispSw := True;
        obj[10+i].x := x + Field[i].SwapOffsetX + fieldpos_x;
        obj[10+i].y := y + Field[i].SwapOffsetY + Field[i].PopupOffset - Field[i].DropOffset;
        obj[10+i].w := BLOCK_WIDTH;
        obj[10+i].h := BLOCK_HEIGHT;
        obj[10+i].tx := colx;
        obj[10+i].ty := coly;
        obj[10+i].Texture := texture[0];
        obj[10+i].alpha := 255;
        { --- äե椫 }
	if Field[i].LineTimer > 0 then
          DispEraseBlock(obj[10+i], Field[i]);
      end;
    end
    else
      obj[10+i].DispSw := False;
  end;
end;

{ ---------------------------------------- }
{ --- ֥åǻե             }
procedure TPuzzleDisp.DispEraseBlock(obj:TGameSprite; bl: PBlock);
begin
  if bl.LineTimer < 3 then
  begin
    obj.tx := 5 * 24;
    obj.ty := 2 * 24;
  end
  else
  begin
    if (bl.LineTimer mod 2) = 0 then
    begin
      obj.tx := 4 * 24;
      obj.ty := 2 * 24;
    end;
  end;
  { -- 餭饨ե }
  if bl.LineTimer = 3 then
  begin
    KiraRequest(obj.x+(BLOCK_WIDTH div 2),obj.y+(BLOCK_HEIGHT div 2), 60);
    KiraRequest(obj.x+(BLOCK_WIDTH div 2),obj.y+(BLOCK_HEIGHT div 2), 60);
    KiraRequest(obj.x+(BLOCK_WIDTH div 2),obj.y+(BLOCK_HEIGHT div 2), 60);
  end;
end;

{ ---------------------------------------- }
{ --- եط                       }
procedure TPuzzleDisp.DispBack;
begin
    obj[0].DispSw := True;
    obj[0].x := 0;
    obj[0].y := 0;
    obj[0].w := 480;
    obj[0].h := 360;
    obj[0].tx := 0;
    obj[0].ty := 0;
    obj[0].Texture := texture[1];
    obj[0].alpha := 255;
    { -------------------------------------- }
    { --- ٤ }
    obj[115].DispSw := True;
    obj[115].x := 81;
    obj[115].y := 316;
    obj[115].w := 192;
    obj[115].h := 4;
    obj[115].tx := 81;
    obj[115].ty := 316;
    obj[115].Texture := texture[1];
    obj[115].alpha := 255;
    obj[116].DispSw := True;
    obj[116].x := 81;
    obj[116].y := 344;
    obj[116].w := 192;
    obj[116].h := 16;
    obj[116].tx := 81;
    obj[116].ty := 344;
    obj[116].Texture := texture[1];
    obj[116].alpha := 255;
    obj[117].DispSw := True;
    obj[117].x := 81;
    obj[117].y := 0;
    obj[117].w := 192;
    obj[117].h := 28;
    obj[117].tx := 81;
    obj[117].ty := 0;
    obj[117].Texture := texture[1];
    obj[117].alpha := 255;
end;

{ ---------------------------------------- }
{ --- 饯˥᡼           }
procedure TPuzzleDisp.DispChara;
var
  i, tanux: Integer;
  koma: Integer;
begin
  texture[3] := screen.GetTexture(8);
  koma := (DispTimer div 4) mod 8;
  obj[9].DispSw := True;
  obj[9].x := fieldpos_x;
  obj[9].y := FieldTop;
  obj[9].w := 192;
  obj[9].h := 288;
  obj[9].tx := animekoma[koma] * 192;
  obj[9].ty := 0;
  obj[9].Texture := Texture[3];
  obj[9].alpha := 255;
  { --- Υ̥ }
  for i := 0 to 3 do
  begin
    tanuki[i].y := tanuki[i].y - 2;
    if tanuki[i].y < 0 then
    begin
      tanuki[i].y := 380 + Random(40);
      tanuki[i].x := Random(BLOCK_WIDTH*FIELD_WIDTH - 60);
    end;
    tanux := Trunc(sin(2*3.1415*(tanuki[i].y mod 120) / 120) * 8);
    obj[i+2].DispSw := True;
    obj[i+2].x := tanuki[i].x + tanux + fieldpos_x + 20;
    obj[i+2].y := tanuki[i].y;
    obj[i+2].w := 36;
    obj[i+2].h := 22;
    obj[i+2].tx := 72;
    obj[i+2].ty := 72;
    obj[i+2].Texture := texture[0];
    obj[i+2].alpha := 255;
  end;
end;

{ ---------------------------------------- }
{ --- NEXT ɽ                          }
procedure TPuzzleDisp.DispNext;
var
  mode: Integer;
begin
  mode := 0;
  if NextTimer < 24 then
  begin
    mode := 32 * (NextTimer mod 2);
  end;
  obj[120].DispSw := True;
  obj[120].x := fieldpos_x + 80;
  obj[120].y := FieldTop + (11 * BLOCK_HEIGHT) + 20;
  obj[120].w := 32;
  obj[120].h := 16;
  obj[120].tx := mode;
  obj[120].ty := 72;
  obj[120].Texture := texture[0];
  obj[120].alpha := 255;
end;

{ ---------------------------------------- }
{ --- Ready-Go! ɽ                     }
procedure TPuzzleDisp.DispReady(time: Integer);
var
  i: Integer;
begin
  if time < 15 then
  begin
    { -- Ready 夬 }
    obj[160].DispSw := True;
    obj[160].x := fieldpos_x + 8;
    obj[160].y := 160 + (15 - time) * 20;
    obj[160].w := 170;
    obj[160].h := 44;
    obj[160].tx := 0;
    obj[160].ty := 0;
    obj[160].Texture := texture[2];
    obj[160].alpha := 255;
  end
  else if time < 45 then
  begin
    { -- Ready }
    obj[160].DispSw := True;
    obj[160].x := fieldpos_x + 8;
    obj[160].y := 160;
    obj[160].w := 170;
    obj[160].h := 44;
    obj[160].tx := 0;
    obj[160].ty := 0;
    obj[160].Texture := texture[2];
    obj[160].alpha := 255;
  end
  else if time < 80 then
  begin
    { -- Go!! }
    obj[160].DispSw := True;
    obj[160].x := fieldpos_x + 40;
    obj[160].y := 160;
    obj[160].w := 114;
    obj[160].h := 44;
    obj[160].tx := 0;
    obj[160].ty := 45;
    obj[160].Texture := texture[2];
    obj[160].alpha := 255;
    { - ѡե }
    if time = 45 then
    begin
      for i := 0 to 32 do
      begin
        KiraRequest(fieldpos_x + 40 + 57, 160+22, 200);
      end;
    end;
  end
  else
  begin
    { -- ä }
    obj[160].DispSw := False;
  end;
end;

{ ---------------------------------------- }
{ --- GAMEOVER ɽ                     }
procedure TPuzzleDisp.DispGameover(time: Integer);
var
  mx, my: Integer;
  home: Integer;
begin
  home := 60;
  { -- G }
  if time > 40 then
  begin
    mx := home;
    my := 160;
  end
  else
  begin
    mx := home + (40 - time) * 12;
    my := 160 + Trunc(sin(2.0 * 3.1415 * (40 - time) / 20.0) * (40 - time) * 6);
  end;
  obj[160].DispSw := True;
  obj[160].x := mx;
  obj[160].y := my;
  obj[160].w := 38;
  obj[160].h := 52;
  obj[160].tx := 0;
  obj[160].ty := 90;
  obj[160].Texture := texture[2];
  obj[160].alpha := 255;
  { -- A }
  if time > 45 then
  begin
    mx := home + 38;
    my := 160;
  end
  else
  begin
    mx := home + 38 + (45 - time) * 12;
    my := 160 + Trunc(sin(2.0 * 3.1415 * (45 - time) / 20.0 + 7) * (45 - time) * 6);
  end;
  obj[161].DispSw := True;
  obj[161].x := mx;
  obj[161].y := my;
  obj[161].w := 37;
  obj[161].h := 52;
  obj[161].tx := 38;
  obj[161].ty := 90;
  obj[161].Texture := texture[2];
  obj[161].alpha := 255;
  { -- M }
  if time > 50 then
  begin
    mx := home + 75;
    my := 160;
  end
  else
  begin
    mx := home + 75 + (50 - time) * 12;
    my := 160 + Trunc(sin(2.0 * 3.1415 * (50 - time) / 20.0 + 2) * (50 - time) * 6);
  end;
  obj[162].DispSw := True;
  obj[162].x := mx;
  obj[162].y := my;
  obj[162].w := 55;
  obj[162].h := 52;
  obj[162].tx := 75;
  obj[162].ty := 90;
  obj[162].Texture := texture[2];
  obj[162].alpha := 255;
  { -- E }
  if time > 55 then
  begin
    mx := home + 130;
    my := 160;
  end
  else
  begin
    mx := home + 130 + (55 - time) * 12;
    my := 160 + Trunc(sin(2.0 * 3.1415 * (55 - time) / 20.0 + 6) * (55 - time) * 6);
  end;
  obj[163].DispSw := True;
  obj[163].x := mx;
  obj[163].y := my;
  obj[163].w := 31;
  obj[163].h := 52;
  obj[163].tx := 130;
  obj[163].ty := 90;
  obj[163].Texture := texture[2];
  obj[163].alpha := 255;
  { -- O }
  if time > 60 then
  begin
    mx := home + 161;
    my := 160;
  end
  else
  begin
    mx := home + 161 + (60 - time) * 12;
    my := 160 + Trunc(sin(2.0 * 3.1415 * (60 - time) / 20.0 + 4) * (60 - time) * 6);
  end;
  obj[164].DispSw := True;
  obj[164].x := mx;
  obj[164].y := my;
  obj[164].w := 45;
  obj[164].h := 52;
  obj[164].tx := 161;
  obj[164].ty := 90;
  obj[164].Texture := texture[2];
  obj[164].alpha := 255;
  { -- V }
  if time > 65 then
  begin
    mx := home + 206;
    my := 160;
  end
  else
  begin
    mx := home + 206 + (65 - time) * 12;
    my := 160 + Trunc(sin(2.0 * 3.1415 * (65 - time) / 20.0 + 2) * (65 - time) * 6);
  end;
  obj[165].DispSw := True;
  obj[165].x := mx;
  obj[165].y := my;
  obj[165].w := 36;
  obj[165].h := 52;
  obj[165].tx := 206;
  obj[165].ty := 90;
  obj[165].Texture := texture[2];
  obj[165].alpha := 255;
  { -- E }
  if time > 70 then
  begin
    mx := home + 242;
    my := 160;
  end
  else
  begin
    mx := home + 242 + (70 - time) * 12;
    my := 160 + Trunc(sin(2.0 * 3.1415 * (70 - time) / 20.0 + 6) * (70 - time) * 6);
  end;
  obj[166].DispSw := True;
  obj[166].x := mx;
  obj[166].y := my;
  obj[166].w := 32;
  obj[166].h := 52;
  obj[166].tx := 242;
  obj[166].ty := 90;
  obj[166].Texture := texture[2];
  obj[166].alpha := 255;
  { -- R }
  if time > 75 then
  begin
    mx := home + 274;
    my := 160;
  end
  else
  begin
    mx := home + 274 + (75 - time) * 12;
    my := 160 + Trunc(sin((2.0 * 3.1415 * (75 - time) / 20.0) + 1) * (75 - time) * 6);
  end;
  obj[167].DispSw := True;
  obj[167].x := mx;
  obj[167].y := my;
  obj[167].w := 34;
  obj[167].h := 52;
  obj[167].tx := 274;
  obj[167].ty := 90;
  obj[167].Texture := texture[2];
  obj[167].alpha := 255;
end;


{ ---------------------------------------- }
{ ---                              }
procedure TPuzzleDisp.DispScore;
begin
  { 168 : SCORE }
  { 169 : BLOCK }
  { 170 : LEVEL }
  { 171-178 : score num (400x48) }
  { 179-183 : block num (424x96) }
  { 184-185 : score num (436x144) }

  { ------------------------------ }
  { --- ʸ }
  obj[168].DispSw := True;
  obj[168].x := 416;
  obj[168].y := 27;
  obj[168].w := 48;
  obj[168].h := 18;
  obj[168].tx := 0;
  obj[168].ty := 16;
  obj[168].Texture := texture[4];
  obj[168].alpha := 255;
  obj[169].DispSw := True;
  obj[169].x := 364;
  obj[169].y := 75;
  obj[169].w := 100;
  obj[169].h := 18;
  obj[169].tx := 0;
  obj[169].ty := 34;
  obj[169].Texture := texture[4];
  obj[169].alpha := 255;
  obj[170].DispSw := True;
  obj[170].x := 421;
  obj[170].y := 123;
  obj[170].w := 43;
  obj[170].h := 18;
  obj[170].tx := 0;
  obj[170].ty := 52;
  obj[170].Texture := texture[4];
  obj[170].alpha := 255;
  DispNum(400, 48, 8, 171, Score);
  DispNum(424, 96, 5, 179, EraseBlock);
  DispNum(436, 144, 2, 184, Level);
end;


{ ------------------------------ }
{ --- οɽ }
procedure TPuzzleDisp.DispNum(x, y, n, o, num: Integer);
var
  i, j: Integer;
  c: Integer;
  top: Boolean;
begin
  { x, y : ɽ }
  { n : ɽʸ }
  { o : Objֹ }
  { num : ɽ }
  top := True;
  j := 1;
  for i := 0 to (n - 1) do
    j := j * 10;
  if num >= j then  num := j - 1;
  for i := 0 to (n - 1) do
  begin
    c := num div (j div 10);
    num := num mod (j div 10);
    if c > 9 then c := 9;
    if i = (n - 1) then top := False;
    { -- ɽ }
    if (c = 0) and (top = True) then
    begin
      obj[o].DispSw := False;
    end
    else
    begin
      top := False;
      obj[o].DispSw := True;
      obj[o].x := x;
      obj[o].y := y;
      obj[o].w := 8;
      obj[o].h := 16;
      obj[o].tx := c * 8;
      obj[o].ty := 0;
      obj[o].Texture := texture[4];
      obj[o].alpha := 255;
    end;
    x := x + 8;
    o := o + 1;
    j := j div 10;
  end;
end;

{ ------------------------------ }
{ --- 餭饨եȤɽ }
procedure TPuzzleDisp.DispKira;
var
  i: Integer;
  alpha: Integer;
  d: Integer;
begin
  for i := 0 to KiraMax do
  begin
    if kirakira[i].DispSw = True then
    begin
      { -- ɽ }
      kirakira[i].x := kirakira[i].x + kirakira[i].dx;
      kirakira[i].y := kirakira[i].y + kirakira[i].dy;
      { -- ư }
      alpha := 255;
      if kirakira[i].timer > (kirakira[i].timer_end div 4) then
      begin
        kirakira[i].dx := (kirakira[i].dx * $c0) div $100;
        kirakira[i].dy := (kirakira[i].dy * $c0) div $100;
        d := kirakira[i].timer - (kirakira[i].timer_end div 2);
        d := (d * 255) div (kirakira[i].timer_end div 2);
        alpha := 255 - d;
        if alpha < 0 then alpha := 0;
        if alpha > 255 then alpha := 255;
      end;
      { -- ɽ }
      kirakira[i].obj.DispSw := True;
      kirakira[i].obj.x := kirakira[i].x div $10000;
      kirakira[i].obj.y := kirakira[i].y div $10000;
      kirakira[i].obj.w := 11;
      kirakira[i].obj.h := 11;
      kirakira[i].obj.tx := 144;
      kirakira[i].obj.ty := 48;
      kirakira[i].obj.Texture := texture[0];
      kirakira[i].obj.alpha := alpha;
      { -- ɽ֤δ }
      kirakira[i].timer := kirakira[i].timer + 1;
      if kirakira[i].timer >= kirakira[i].timer_end then
      begin
        kirakira[i].obj.DispSw := False;
        kirakira[i].DispSw := False;
      end;
    end;
  end;
end;

{ ------------------------------ }
{ --- 餭饨եȤΥꥯ }
procedure TPuzzleDisp.KiraRequest(x, y, l: Integer);
var
  i, j: Integer;
  hit : Boolean;
begin
  hit := False;
  { -- եȤõ }
  for i := 0 to KiraMax do
  begin
    if kirakira[i].DispSw = False then
    begin
      hit := True;
      j := i;
      break;
    end;
  end;
  { -- ꥯ }
  if hit = True then
  begin
    kirakira[j].DispSw := True;
    kirakira[j].timer := 0;
    kirakira[j].timer_end := 15;
    kirakira[j].x := x * $10000;
    kirakira[j].y := y * $10000;
    kirakira[j].dx := Trunc(cos(Random(360) * 2.0 * 3.1415 / 360) * (l / 15.0) * $10000);
    kirakira[j].dy := Trunc(sin(Random(360) * 2.0 * 3.1415 / 360) * (l / 15.0) * $10000);
  end;
end;


end.
