{--------------------------------------------------------}
{                                                        }
{ SDL puzzle project - for COMIKET62                     }
{                        Fumi2Kick/LiMo/omamori-2002     }
{                        1st Maintaner  Rerorero@fumi.   }
{                                                        }
{   puz_trial.pp                                         }
{     ѥ륲 ȤȤ⡼                        }
{                                                        }
{--------------------------------------------------------}
{ -- $Id: puz_trial.pp,v 1.3 2002/08/10 03:05:14 rero2 Exp $ }
Unit Puz_Trial;

{$MODE Delphi}


interface

Uses classes, Input, Grp_Screen, Puz_Base, Puz_Disp, Debug;


Type
  TrialStep = (TInit, TReady, TGame, TMiss, TGameover, TEnd);

  { ------------------------------------- }
  { ----- ȤȤ⡼ɥ饹 }
  TPuzzleTrial = class(TPuzzleDisp)
    { --------------------------- }
    { ---  }
    private
    Screen: TGameScreen;
    Step: TrialStep;
    ReadyTimer: Integer;
    procedure ChangeCharacter(level: Integer);
    { ------------------- }
    { --- ʬ }
    public
    Status: Boolean;
    constructor Create(scr: TGameScreen);
    destructor Destroy; Override;
    procedure LoadTexture;
    procedure GameMain;
    function GameStat: Boolean;
    procedure UserControl;
  end;



implementation

uses sound;

{ -------------------------------------------------------------- }
{ --- ȤȤ⡼ɴ饹                                   }
{ -------------------------------------------------------------- }

{ ---------------------------------------- }
{ --- 󥹥ȥ饯ǥȥ饯         }

constructor TPuzzleTrial.Create(scr: TGameScreen);
begin
  Step := TInit;
  Status := True;
  Screen := scr;
  LoadTexture;

  inherited Create(MODE_CHALLENGE, scr);
end;

destructor TPuzzleTrial.Destroy;
begin
  inherited;
end;


{ ---------------------------------------- }
{ --- ѥƥɤ߹         }

procedure TPuzzleTrial.LoadTexture;
begin
  Screen.LoadTexture(2, 'parts001.pac');
  Screen.LoadTexture(4, 'trial_back00.pac');
  Screen.LoadTexture(6, 'parts002.pac');
  Screen.LoadTexturePure(8, 'chara01_1.pac');
  Screen.LoadTexture(10, 'parts003.pac');
end;


{ ---------------------------------------- }
{ --- ٥륢åפˤؤ             }
procedure TPuzzleTrial.ChangeCharacter(level: Integer);
begin
  case level of
     6: Screen.LoadTexturePure(8, 'chara01_2.pac');
    11: Screen.LoadTexturePure(8, 'chara01_3.pac');
    16: Screen.LoadTexturePure(8, 'chara01_4.pac');
    21: Screen.LoadTexturePure(8, 'chara01_5.pac');
    26: Screen.LoadTexturePure(8, 'chara01_6.pac');
  end;
end;

{ ---------------------------------------- }
{ --- ¹椫ɤ֤ե饰     }

function TPuzzleTrial.GameStat: Boolean;
var
  r: Boolean;
begin
  r := True;
  if Step = TEnd then  r := False;
  GameStat := r;
end;


{ ---------------------------------------- }
{ --- ʬμ¹                 }

procedure TPuzzleTrial.GameMain;
var
  i, j, k: Integer;
begin
  { --------------------------------------------- }
  { --- ѥ륲ॹƥå  }
  case Step of
    { ---  }
    TInit:
      begin
        { -- (TPuzzleBase) }
        GameInit(1);
        GamePause(STEP_PAUSE);
	SoundSE(3);
        ReadyTimer := 0;
        Step := TReady;
      end;

    { --- ೫ }
    TReady:
      begin
        GameExec;
        DispField;
        DispReady(ReadyTimer);
        { - ֤Ǽ }
        ReadyTimer := ReadyTimer + 1;
        if ReadyTimer > 84 then
        begin
          SoundMusic(3);
          GamePause(STEP_LINECHECK);
          Step := TGame;
        end;
      end;

    { ---  }
    TGame:
      begin
        UserControl;
        GameExec;
        if LevelCheck = True then
        begin
          { --- ٥륢å׻ȥ饯 }
          GameLevel(Level);
          ChangeCharacter(Level);
          SoundSE(2);
          for i := 0 to 16 do
            KiraRequest(444, 152, 80);
        end;
        DispField;
        { - ४СǼ }
        if GameOver = True then
        begin
          SoundMusicStop;
          SoundSE(7);
          ReadyTimer := 0;
          Step := TMiss;
        end;
      end;

    { --- λ }
    TMiss:
      begin
        { -- ֥å򳥿 }
        j := (ReadyTimer div 2) + 1;
        for i := 0 to FIELD_WIDTH - 1 do
        begin
          if Field[j*FIELD_WIDTH + i] <> nil then
          begin
            if Field[j*FIELD_WIDTH + i].Color < $10 then
              Field[j*FIELD_WIDTH + i].Color := Field[j*FIELD_WIDTH + i].Color + $10;
          end;
        end;
        DispField;
        { -- }
        ReadyTimer := ReadyTimer + 1;
        if ReadyTimer = ((FIELD_HEIGHT - 1) * 2) then
        begin
          SoundMusicOneshot(1);
          ReadyTimer := 0;
          Step := TGameOver;
        end;
      end;

    { --- ४С }
    TGameover:
      begin
        DispGameover(ReadyTimer);
        i := InputJoyKeyTriger(0);
        ReadyTimer := ReadyTimer + 1;
        if ReadyTimer > 80 then
          if (i and IN_Button1) <> 0 then
            Step := TEnd;
        if ReadyTimer > 180 then
        begin
          SoundMusicStop;
          Step := TEnd;
        end;
      end;

    { --- ѥ륯饹λ }
    TEnd:
      begin
      end;
  end;
end;


{ ---------------------------------------- }
{ --- 桼ȥ                }

procedure TPuzzleTrial.UserControl;
var
  inp: Integer;
begin
  { --- ؤ }
  if GameStep = STEP_SWAP then exit;
  { --- Ϥȥۡ }
  ua.HaveBlock := False;
  inp := InputJoyKey(0);
  if ((inp and IN_Button1) <> 0) and (Animation = False) then
  begin
    { -- ߤΥ֤˥֥åϤ뤫 }
    if Field[ua.x + (ua.y * FIELD_WIDTH)] <> nil then
    begin
      ua.HaveBlock := True;
    end;
  end;
  { --- Ϥȥư }
  inp := InputJoyKeyTriger(0);
  if ((inp and IN_Up) <> 0) and (ua.y < (FIELD_HEIGHT -1)) then
  begin
    if ua.HaveBlock = True then
    begin
      MoveRequest(ua.x, ua.y, MOVE_UP);
    end;
    ua.y := ua.y + 1;
  end;
  if ((inp and IN_Down) <> 0) and (ua.y > 1) then
  begin
    if ua.HaveBlock = True then
    begin
      MoveRequest(ua.x, ua.y, MOVE_DOWN);
    end;
    ua.y := ua.y - 1;
  end;
  if ((inp and IN_Left) <> 0) and (ua.x > 0) then
  begin
    if ua.HaveBlock = True then
    begin
      MoveRequest(ua.x, ua.y, MOVE_LEFT);
    end;
    ua.x := ua.x - 1;
  end;
  if ((inp and IN_Right) <> 0) and (ua.x < (FIELD_WIDTH -1)) then
  begin
    if ua.HaveBlock = True then
    begin
      MoveRequest(ua.x, ua.y, MOVE_RIGHT);
    end;
    ua.x := ua.x + 1;
  end;
end;



end.
